using ZXCalculus, LightGraphs
include("../script/zx_plot.jl")

function gen_cir()
    cir = ZXDiagram(5)
    push_gate!(cir, Val{:X}(), 5, 1//1)
    push_gate!(cir, Val{:H}(), 5)
    push_gate!(cir, Val{:Z}(), 5)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 4)
    push_gate!(cir, Val{:Z}(), 5, 7//4)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 1)
    push_gate!(cir, Val{:Z}(), 5, 1//4)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 4)
    push_gate!(cir, Val{:Z}(), 4, 1//4)
    push_gate!(cir, Val{:Z}(), 5, 7//4)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 1)
    push_ctrl_gate!(cir, Val{:CNOT}(), 4, 1)
    push_gate!(cir, Val{:Z}(), 5, 1//4)
    push_gate!(cir, Val{:Z}(), 1, 1//4)
    push_gate!(cir, Val{:Z}(), 4, 7//4)
    push_ctrl_gate!(cir, Val{:CNOT}(), 4, 1)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 4)
    push_gate!(cir, Val{:Z}(), 5, 7//4)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 3)
    push_gate!(cir, Val{:Z}(), 5, 1//4)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 4)
    push_gate!(cir, Val{:Z}(), 4, 1//4)
    push_gate!(cir, Val{:Z}(), 5, 7//4)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 3)
    push_ctrl_gate!(cir, Val{:CNOT}(), 4, 3)
    push_gate!(cir, Val{:Z}(), 5, 1//4)
    push_gate!(cir, Val{:Z}(), 3, 1//4)
    push_gate!(cir, Val{:Z}(), 4, 7//4)
    push_gate!(cir, Val{:H}(), 5)
    push_gate!(cir, Val{:Z}(), 5)
    push_ctrl_gate!(cir, Val{:CNOT}(), 4, 3)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 4)
    push_gate!(cir, Val{:H}(), 5)
    push_gate!(cir, Val{:Z}(), 5)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 3)
    push_gate!(cir, Val{:Z}(), 5, 7//4)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 2)
    push_gate!(cir, Val{:Z}(), 5, 1//4)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 3)
    push_gate!(cir, Val{:Z}(), 3, 1//4)
    push_gate!(cir, Val{:Z}(), 5, 7//4)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 2)
    push_ctrl_gate!(cir, Val{:CNOT}(), 3, 2)
    push_gate!(cir, Val{:Z}(), 5, 1//4)
    push_gate!(cir, Val{:H}(), 5)
    push_gate!(cir, Val{:Z}(), 2, 1//4)
    push_gate!(cir, Val{:Z}(), 3, 7//4)
    push_gate!(cir, Val{:Z}(), 5)
    push_ctrl_gate!(cir, Val{:CNOT}(), 3, 2)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 3)
    push_gate!(cir, Val{:H}(), 5)
    push_gate!(cir, Val{:Z}(), 5)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 2)
    push_gate!(cir, Val{:Z}(), 5, 7//4)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 1)
    push_gate!(cir, Val{:Z}(), 5, 1//4)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 2)
    push_gate!(cir, Val{:Z}(), 2, 1//4)
    push_gate!(cir, Val{:Z}(), 5, 7//4)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 1)
    push_ctrl_gate!(cir, Val{:CNOT}(), 2, 1)
    push_gate!(cir, Val{:Z}(), 5, 1//4)
    push_gate!(cir, Val{:Z}(), 1, 1//4)
    push_gate!(cir, Val{:Z}(), 2, 7//4)
    push_gate!(cir, Val{:H}(), 5)
    push_gate!(cir, Val{:Z}(), 5)
    push_ctrl_gate!(cir, Val{:CNOT}(), 2, 1)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 2)
    push_ctrl_gate!(cir, Val{:CNOT}(), 5, 1)
    return cir
end

cir = gen_cir()
ZXplot(cir)
ZXplot(ZXGraph(cir))

tcount(cir) = sum([phase(cir, v) % 1//2 != 0 for v in spiders(cir)])
println(spiders(cir)[[phase(cir, v) % 1//2 != 0 for v in spiders(cir)]])
tcount(cir)

cir2 = phase_teleportation(cir)
println(spiders(cir2)[[phase(cir2, v) % 1//2 != 0 for v in spiders(cir2)]])
tcount(cir2)
for vs in cir2.layout.spider_seq
    println(vs)
end
ZXplot(cir2)
